import * as jspb from "google-protobuf"

import * as common_search$criteria_pb from '../common/search-criteria_pb';
import * as common_search$pagination_pb from '../common/search-pagination_pb';
import * as common_search$sort_pb from '../common/search-sort_pb';
import * as user_user_pb from '../user/user_pb';

export class CreateUserRequest extends jspb.Message {
  getApi(): string;
  setApi(value: string): void;

  getUser(): user_user_pb.User | undefined;
  setUser(value?: user_user_pb.User): void;
  hasUser(): boolean;
  clearUser(): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): CreateUserRequest.AsObject;
  static toObject(includeInstance: boolean, msg: CreateUserRequest): CreateUserRequest.AsObject;
  static serializeBinaryToWriter(message: CreateUserRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): CreateUserRequest;
  static deserializeBinaryFromReader(message: CreateUserRequest, reader: jspb.BinaryReader): CreateUserRequest;
}

export namespace CreateUserRequest {
  export type AsObject = {
    api: string,
    user?: user_user_pb.User.AsObject,
  }
}

export class CreateUserResponse extends jspb.Message {
  getApi(): string;
  setApi(value: string): void;

  getId(): number;
  setId(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): CreateUserResponse.AsObject;
  static toObject(includeInstance: boolean, msg: CreateUserResponse): CreateUserResponse.AsObject;
  static serializeBinaryToWriter(message: CreateUserResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): CreateUserResponse;
  static deserializeBinaryFromReader(message: CreateUserResponse, reader: jspb.BinaryReader): CreateUserResponse;
}

export namespace CreateUserResponse {
  export type AsObject = {
    api: string,
    id: number,
  }
}

export class ReadUserByIdRequest extends jspb.Message {
  getApi(): string;
  setApi(value: string): void;

  getId(): number;
  setId(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ReadUserByIdRequest.AsObject;
  static toObject(includeInstance: boolean, msg: ReadUserByIdRequest): ReadUserByIdRequest.AsObject;
  static serializeBinaryToWriter(message: ReadUserByIdRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ReadUserByIdRequest;
  static deserializeBinaryFromReader(message: ReadUserByIdRequest, reader: jspb.BinaryReader): ReadUserByIdRequest;
}

export namespace ReadUserByIdRequest {
  export type AsObject = {
    api: string,
    id: number,
  }
}

export class ReadUserByUsernameRequest extends jspb.Message {
  getApi(): string;
  setApi(value: string): void;

  getUsername(): string;
  setUsername(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ReadUserByUsernameRequest.AsObject;
  static toObject(includeInstance: boolean, msg: ReadUserByUsernameRequest): ReadUserByUsernameRequest.AsObject;
  static serializeBinaryToWriter(message: ReadUserByUsernameRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ReadUserByUsernameRequest;
  static deserializeBinaryFromReader(message: ReadUserByUsernameRequest, reader: jspb.BinaryReader): ReadUserByUsernameRequest;
}

export namespace ReadUserByUsernameRequest {
  export type AsObject = {
    api: string,
    username: string,
  }
}

export class ReadUserResponse extends jspb.Message {
  getApi(): string;
  setApi(value: string): void;

  getUser(): user_user_pb.User | undefined;
  setUser(value?: user_user_pb.User): void;
  hasUser(): boolean;
  clearUser(): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ReadUserResponse.AsObject;
  static toObject(includeInstance: boolean, msg: ReadUserResponse): ReadUserResponse.AsObject;
  static serializeBinaryToWriter(message: ReadUserResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ReadUserResponse;
  static deserializeBinaryFromReader(message: ReadUserResponse, reader: jspb.BinaryReader): ReadUserResponse;
}

export namespace ReadUserResponse {
  export type AsObject = {
    api: string,
    user?: user_user_pb.User.AsObject,
  }
}

export class UpdateUserRequest extends jspb.Message {
  getApi(): string;
  setApi(value: string): void;

  getUser(): user_user_pb.User | undefined;
  setUser(value?: user_user_pb.User): void;
  hasUser(): boolean;
  clearUser(): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UpdateUserRequest.AsObject;
  static toObject(includeInstance: boolean, msg: UpdateUserRequest): UpdateUserRequest.AsObject;
  static serializeBinaryToWriter(message: UpdateUserRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UpdateUserRequest;
  static deserializeBinaryFromReader(message: UpdateUserRequest, reader: jspb.BinaryReader): UpdateUserRequest;
}

export namespace UpdateUserRequest {
  export type AsObject = {
    api: string,
    user?: user_user_pb.User.AsObject,
  }
}

export class UpdateUserResponse extends jspb.Message {
  getApi(): string;
  setApi(value: string): void;

  getUpdated(): number;
  setUpdated(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UpdateUserResponse.AsObject;
  static toObject(includeInstance: boolean, msg: UpdateUserResponse): UpdateUserResponse.AsObject;
  static serializeBinaryToWriter(message: UpdateUserResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UpdateUserResponse;
  static deserializeBinaryFromReader(message: UpdateUserResponse, reader: jspb.BinaryReader): UpdateUserResponse;
}

export namespace UpdateUserResponse {
  export type AsObject = {
    api: string,
    updated: number,
  }
}

export class DeleteUserRequest extends jspb.Message {
  getApi(): string;
  setApi(value: string): void;

  getId(): number;
  setId(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): DeleteUserRequest.AsObject;
  static toObject(includeInstance: boolean, msg: DeleteUserRequest): DeleteUserRequest.AsObject;
  static serializeBinaryToWriter(message: DeleteUserRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): DeleteUserRequest;
  static deserializeBinaryFromReader(message: DeleteUserRequest, reader: jspb.BinaryReader): DeleteUserRequest;
}

export namespace DeleteUserRequest {
  export type AsObject = {
    api: string,
    id: number,
  }
}

export class DeleteUserResponse extends jspb.Message {
  getApi(): string;
  setApi(value: string): void;

  getDeleted(): number;
  setDeleted(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): DeleteUserResponse.AsObject;
  static toObject(includeInstance: boolean, msg: DeleteUserResponse): DeleteUserResponse.AsObject;
  static serializeBinaryToWriter(message: DeleteUserResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): DeleteUserResponse;
  static deserializeBinaryFromReader(message: DeleteUserResponse, reader: jspb.BinaryReader): DeleteUserResponse;
}

export namespace DeleteUserResponse {
  export type AsObject = {
    api: string,
    deleted: number,
  }
}

export class ReadAllUsersRequest extends jspb.Message {
  getApi(): string;
  setApi(value: string): void;

  getPagination(): common_search$pagination_pb.SearchPagination | undefined;
  setPagination(value?: common_search$pagination_pb.SearchPagination): void;
  hasPagination(): boolean;
  clearPagination(): void;

  getSort(): common_search$sort_pb.SearchSort | undefined;
  setSort(value?: common_search$sort_pb.SearchSort): void;
  hasSort(): boolean;
  clearSort(): void;

  getCriteriaList(): Array<common_search$criteria_pb.SearchCriteria>;
  setCriteriaList(value: Array<common_search$criteria_pb.SearchCriteria>): void;
  clearCriteriaList(): void;
  addCriteria(value?: common_search$criteria_pb.SearchCriteria, index?: number): common_search$criteria_pb.SearchCriteria;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ReadAllUsersRequest.AsObject;
  static toObject(includeInstance: boolean, msg: ReadAllUsersRequest): ReadAllUsersRequest.AsObject;
  static serializeBinaryToWriter(message: ReadAllUsersRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ReadAllUsersRequest;
  static deserializeBinaryFromReader(message: ReadAllUsersRequest, reader: jspb.BinaryReader): ReadAllUsersRequest;
}

export namespace ReadAllUsersRequest {
  export type AsObject = {
    api: string,
    pagination?: common_search$pagination_pb.SearchPagination.AsObject,
    sort?: common_search$sort_pb.SearchSort.AsObject,
    criteriaList: Array<common_search$criteria_pb.SearchCriteria.AsObject>,
  }
}

export class ReadAllUsersResponse extends jspb.Message {
  getApi(): string;
  setApi(value: string): void;

  getTotalcount(): number;
  setTotalcount(value: number): void;

  getUsersList(): Array<user_user_pb.User>;
  setUsersList(value: Array<user_user_pb.User>): void;
  clearUsersList(): void;
  addUsers(value?: user_user_pb.User, index?: number): user_user_pb.User;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ReadAllUsersResponse.AsObject;
  static toObject(includeInstance: boolean, msg: ReadAllUsersResponse): ReadAllUsersResponse.AsObject;
  static serializeBinaryToWriter(message: ReadAllUsersResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ReadAllUsersResponse;
  static deserializeBinaryFromReader(message: ReadAllUsersResponse, reader: jspb.BinaryReader): ReadAllUsersResponse;
}

export namespace ReadAllUsersResponse {
  export type AsObject = {
    api: string,
    totalcount: number,
    usersList: Array<user_user_pb.User.AsObject>,
  }
}

